[![Build Status](https://github.com/JuliaServices/AutoHashEquals.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaServices/AutoHashEquals.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaServices/AutoHashEquals.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaServices/AutoHashEquals.jl)

# AutoHashEquals.jl - Automatically define hash and equals for Julia.

A macro to add `isequal`, `==`, and `hash()` to struct types: `@auto_hash_equals`.

# `@auto_hash_equals`

The macro `@auto_hash_equals` produces an implementation of `Base.hash(x)` that computes the hash code when invoked.

You use it like so:

```julia
@auto_hash_equals struct Box{T}
    x::T
end
```

which is translated to

```julia
struct Box{T}
    x::T
end
Base.hash(x::Box, h::UInt) = hash(x.x, hash(:Box, h))
Base.(:(==))(a::Box, b::Box) = a.x == b.x
Base.isequal(a::Box, b::Box) = isequal(a.x, b.x)
```

We do not take the type arguments of a generic type into account for `isequal`, `hash`, or `==` unless `typearg=true` is specified (see below).  So by default, a `Box{Int}(1)` will test equal to a `Box{Any}(1)`.

## User-specified hash function

You can specify the hash function to be implemented, by naming it before the struct definition with a keyword argument `hashfn`:

```julia
@auto_hash_equals hashfn=SomePackage.myhash struct Foo
    x
    y
end
```

In this case the macro implements both `SomePackage.myhash` and `Base.hash` for `Foo`.`

## Caching the hash value

You can have the hash value precomputed and stored in a hidden field, by adding the keyword argument `cache=true`. This useful for non-mutable struct types that define recursive or deep data structures (and therefore are likely to be stored on the heap).  It computes the hash code during construction and caches it in a field of the struct.  If you are working with data structures of any significant depth, computing the hash once can speed things up at the expense of one additional field per struct.

```julia
@auto_hash_equals cache=true struct Box{T}
    x::T
end
```

this translates to

```julia
struct Box{T}
    x::T
    _cached_hash::UInt
    function Box{T}(x) where T
        new(x, Base.hash(x, Base.hash(:Box)))
    end
end
function Base.hash(x::Box, h::UInt)
    Base.hash(x._cached_hash, h)
end
function Base.hash(x::Box)
    x._cached_hash
end
function Base._show_default(io::IO, x::Box)
    AutoHashEqualsCached._show_default_auto_hash_equals_cached(io, x)
end
# Note: the definition of `==` is more complicated when there are more fields,
# in order to handle `missing` correctly. See below for a more complicated example.
function Base.:(==)(a::Box, b::Box)
    a._cached_hash == b._cached_hash && Base.:(==)(a.x, b.x)
end
function Base.isequal(a::Box, b::Box)
    a._cached_hash == b._cached_hash && Base.isequal(a.x, b.x)
end
function Box(x::T) where T
    Box{T}(x)
end
```

The definition of `_show_default(io,x)` prevents display of the `_cached_hash` field while preserving the behavior of `Base.show(...)` that handles self-recursive data structures without a stack overflow.

We provide an external constructor for generic types so that you get the same type inference behavior you would get in the absence of this macro.  Specifically, you can write `Box(1)` to get an object of type `Box{Int}`.

## Specifying significant fields

You can specify which fields should be significant for the purposes of computing the hash function and checking equality:

```julia
@auto_hash_equals fields=(a,b) struct Foo
    a
    b
    c
end
```

this translates to

```julia
struct Foo
    a
    b
    c
end
function Base.hash(x::Foo, h::UInt)
    Base.hash(x.b, Base.hash(x.a, Base.hash(:Foo, h)))
end
function Base.isequal(a::Foo, b::Foo)
    Base.isequal(a.a, b.a) && Base.isequal(a.b, b.b)
end
# Returns `false` if any two fields compare as false; otherwise, `missing` if at least
# one comparison is missing. Otherwise `true`.
# This matches the semantics of `==` for Tuple's and NamedTuple's.
function Base.:(==)(a::Foo, b::Foo)
    found_missing = false
    cmp = a.a == b.a
    cmp === false && return false
    if ismissing(cmp)
        found_missing = true
    end
    cmp = a.b == b.b
    cmp === false && return false
    if ismissing(cmp)
        found_missing = true
    end
    found_missing && return missing
    return true
end
```

## Specifying whether or not type arguments should be significant

You can specify that type arguments should be significant for the purposes of computing the hash function and checking equality by adding the keyword parameter `typearg=true`.  By default they are not significant.  You can specify the default (they are not significant) with `typearg=false`:

```julia
julia> @auto_hash_equals struct Box1{T}
           x::T
       end
Box1

julia> Box1{Int}(1) == Box1{Any}(1)
true

julia> hash(Box1{Int}(1))
0x05014b35fc91d289

julia> hash(Box1{Any}(1))
0x05014b35fc91d289

julia> @auto_hash_equals typearg=true struct Box2{T}
           x::T
       end
Box2

julia> Box2{Int}(1) == Box2{Any}(1)
false

julia> hash(Box2{Int}(1))
0x467811eefea1d458

julia> hash(Box2{Any}(1))
0x3042fd2f8fe839d7
```

## Specifying the "type seed"

When we compute the hash function, we start with a "seed" specific to the type being hashed.
By default, the seed is computed as `Base.hash(:TypeName)` if `typearg=false` (which is the default).
If `typearg=true` was specified, then the seed is computed as `type_seed(Type)`,
where `Type` is the type of the instance, including any type arguments.  `type_seed` is a
stable hash function defined (but not exported) in this package.

You can select the seed to be used by specifying `typeseed=e`.

The seed provided (`e`) is used in one of two ways, depending on the setting for `typearg`.
If `typearg=false` (the default), then the value `e` will be used as the type seed.
If `typearg=true`, then `e(t)` is used as the type seed, where `t` is the type of the object being hashed.

Note that the value of `typeseed` is expected to be a `UInt` value when `typearg=false` (or `typearg` is not specified),
but a function that takes a type as its argument when `typearg=true`.

## Compatibility mode

In versions `v"1.0"` and earlier of `AutoHashEquals`, we produced a specialization of `Base.==`, implemented using `Base.isequal`.
This was not correct.
See https://docs.julialang.org/en/v1/base/base/#Base.isequal and https://docs.julialang.org/en/v1/base/math/#Base.:==.
More correct would be to define `==` by using `==` on the members, and to define `isequal` by using `isequal` on the members.
In version `v"2.0"` we provide a correct implementation, thanks to @ericphanson.

To get the same behavior as `v"1.0"` of this package, in which `==` is implemented based on `isequal`,
you can specify `compat1=true`.

```julia
@auto_hash_equals struct Box890{T}
    x::T
end
@assert ismissing(Box890(missing) == Box890(missing))
@assert isequal(Box890(missing), Box890(missing))
@assert ismissing(Box890(missing) == Box890(1))
@assert !isequal(Box890(missing), Box890(1))

@auto_hash_equals compat1=true struct Box891{T}
    x::T
end
@assert Box891(missing) == Box891(missing)
@assert isequal(Box891(missing), Box891(missing))
@assert Box891(missing) != Box891(1)
@assert !isequal(Box891(missing), Box891(1))
```

If you need compatibility mode always and don't want to have to specify the mode on each invocation,
you can instead import the compatibility version of the macro, which defaults to `compat1=true':

```julia
using AutoHashEquals.Compat
```

# SPDX-License-Identifier: MIT

module AutoHashEquals

export @auto_hash_equals

include("type_seed.jl")
include("impl.jl")
include("compat.jl")

"""
    @auto_hash_equals [options] struct Foo ... end

Generate `Base.hash`, `Base.isequal`, and `Base.==` methods for `Foo`.

Options:

* `cache=true|false` whether or not to generate an extra cache field to store the precomputed hash value. Default: `false`.
* `hashfn=myhash` the hash function to use. Default: `Base.hash`.
* `fields=a,b,c` the fields to use for hashing and equality. Default: all fields.
* `typearg=true|false` whether or not to make type arguments significant. Default: `false`.
* `typeseed=e` Use `e` (or `e(type)` if `typearg=true`) as the seed for hashing type arguments.
* `compat1=true` To have `==` defined by using `isequal`.  Default: `false`.
"""
macro auto_hash_equals(args...)
    kwargs = Dict{Symbol,Any}()
    length(args) > 0 || error_usage(__source__)
    for option in args[1:end-1]
        if !isexpr(option, :(=), 2) || !(option.args[1] isa Symbol)
            error_usage(__source__, "expected keyword argument of the form `key=value`, but saw `$option`.")
        end
        name=option.args[1]
        value=option.args[2]
        if name == :fields
            # fields=a,b,c
            if value isa Symbol
                value = (value,)
            elseif isexpr(value, :tuple)
                value = Symbol[value.args...]
                value=(value...,)
            else
                error_usage(__source__, "expected tuple or symbol for `fields`, but got `$value`.")
            end
        end
        kwargs[name] = value
    end
    typ = args[end]
    auto_hash_equals_impl(__source__, typ; kwargs...)
end

end # module

module compat

using AutoHashEquals.Compat: @auto_hash_equals
using Test

@testset "test the compat macro" begin
    @auto_hash_equals struct Box851{T}
        x::T
    end
    @test Box851(missing) == Box851(missing)
    @test isequal(Box851(missing), Box851(missing))
    @test Box851(missing) != Box851(1)
    @test !isequal(Box851(missing), Box851(1))
end

end

"""
    type_seed(x)

Computes a value to use as a seed for computing the hash value of a type.

The constants used in this computation are random numbers
produced by `Random.rand(Random.RandomDevice(), UInt)`.
"""
function type_seed end

function type_seed(m::Module, h::UInt)
    if m === Main || m === Base || m === Core
        return h
    else
        mp = parentmodule(m)
        if mp === m
            return h
        else
            return type_seed(nameof(m), type_seed(mp, h))
        end
    end
end

function type_seed(t::UnionAll, h::UInt)
    h = hash(h, 0xbd5f3e4941dba79d)
    h = type_seed(t.var, h)
    h = type_seed(t.body, h)
    return h
end

function type_seed(x::Union, h::UInt)
    h = hash(h, 0xa16a31201c4852c2)
    for t in Base.uniontypes(x)
        h = type_seed(t, h)
    end
    return h
end

function type_seed(t::TypeVar, h::UInt)
    h = hash(h, 0xc921c42a65aee273)
    h = type_seed(t.name, h)
    h = type_seed(t.lb, h)
    h = type_seed(t.ub, h)
    return h
end

function type_seed(t::DataType, h::UInt)
    h = hash(h, 0x5e90a8c7e280e39b)
    tn = t.name
    if (isdefined(tn, :module))
        h0 = 0xae72cbeead1b2d46
        h0 = type_seed(tn.module, h0)
        h = hash(h, h0)
    end
    h = type_seed(tn.name, h)
    if !isempty(t.parameters)
        h0 = 0x9f86d3fbe4382c06
        for p in t.parameters
            h0 = type_seed(p, h0)
        end
        h = hash(h, h0)
    end
    return h
end

function type_seed(t::Core.TypeofBottom, h::UInt)
    return hash(h, 0x68f57dd85252e163)
end

#
# The following two meta-types changed representation in 1.7, so we are
# explicit about their hashes to ensure stability from 1.6 to 1.7.
#
type_seed(::Type{NTuple}, h::UInt) = 0x789db08b2c84bf6c
type_seed(::Type{Tuple}, h::UInt) = 0x571b7e681184913a

#
# The hash of these types changed in Julia 1.7, so we are explicit to ensure stability
#
function type_seed(t::Tuple, h::UInt)
    h = hash(h, 0x6ccd6cd06f6531b3)
    for e in t
        h = type_seed(e, h)
    end
    return h
end
function type_seed(t::NamedTuple, h::UInt)
    h = hash(h, 0x2014f9d53d478b4f)
    h = type_seed(fieldnames(typeof(t)), h)
    for e in t
        h = type_seed(e, h)
    end
    return h
end

#
# For non-type values (e.g. `x` in `Val{x}`) we delegate to Base.hash.
# Note, however, that Julia 1.7 changed the implementation of Base.hash(::Symbol, ::UInt),
# yet retained stability of `Base.hash(::Symbol)`.   We take advantage of that to make
# the type seed computation stable even back to Julia 1.6 for types whose hashes are
# unstable in that way.
#
type_seed(x, h::UInt) = Base.hash(Base.hash(x), h)

type_seed(x) = type_seed(x, UInt(0))

const is_expr = Base.Meta.isexpr

function if_has_package(
    action::Function,
    name::String,
    uuid::Base.UUID,
    version::VersionNumber
)
    pkgid = Base.PkgId(uuid, name)
    if Base.root_module_exists(pkgid)
        pkg = Base.root_module(pkgid)
        if Base.pkgversion(pkg) >= version
            return action(pkg)
        end
    end
end

function error_usage(__source__, problem=nothing)
    if isnothing(problem)
        problem = ""
    end
    error("$(__source__.file):$(__source__.line): $problem  Usage:\n\n$(@doc AutoHashEquals.@auto_hash_equals)")
end

# `_show_default_auto_hash_equals_cached` is just like `Base._show_default(io, x)`,
# except it ignores fields named `_cached_hash`.  This function is called in the
# implementation of `T._show_default` for each type `T` annotated with
# `@auto_hash_equals cached=true`.  This is ultimately used in the implementation of
# `Base.show`.  This specialization ensures that showing circular data structures does not
# result in infinite recursion.
function _show_default_auto_hash_equals_cached(io::IO, @nospecialize(x))
    t = typeof(x)
    show(io, Base.inferencebarrier(t)::DataType)
    print(io, '(')
    recur_io = IOContext(io, Pair{Symbol,Any}(:SHOWN_SET, x),
                         Pair{Symbol,Any}(:typeinfo, Any))
    if !Base.show_circular(io, x)
        for i in 1:nfields(x)
            f = fieldname(t, i)
            if (f === :_cached_hash)
                continue
            elseif i > 1
                print(io, ", ")
            end
            isdefined(x, f) ? show(recur_io, getfield(x, i)) : print(io, Base.undef_ref_str)
        end
    end
    print(io,')')
end

# Find the first struct declaration buried in the Expr.
get_struct_decl(__source__, typ) = nothing
function get_struct_decl(__source__, typ::Expr)
    if typ.head === :struct
        return typ
    elseif typ.head === :macrocall
        return get_struct_decl(__source__, typ.args[3])
    end

    error_usage(__source__)
end

unpack_name(node) = node
function unpack_name(node::Expr)
    if node.head === :macrocall
        return unpack_name(node.args[3])
    elseif node.head in (:(<:), :(::))
        return unpack_name(node.args[1])
    else
        return node
    end
end

unpack_type_name(__source__, n::Symbol) = (n, n, nothing)
function unpack_type_name(__source__, n::Expr)
    if n.head === :curly
        type_name = n.args[1]
        type_name isa Symbol ||
            error_usage(__source__, "macro @auto_hash_equals applied to type with invalid signature: `$type_name`.")
        where_list = n.args[2:length(n.args)]
        type_params = map(unpack_name, where_list)
        full_type_name = Expr(:curly, type_name, type_params...)
        return (type_name, full_type_name, where_list)
    elseif n.head === :(<:)
        return unpack_type_name(__source__, n.args[1])
    else
        error_usage(__source__, "macro @auto_hash_equals applied to type with invalid signature: `$n`.")
    end
end

function get_fields(__source__, struct_decl::Expr; prevent_inner_constructors=false)
    member_names = Vector{Symbol}()
    member_decls = Vector()

    add_field(__source__, b) = nothing
    function add_field(__source__, b::Symbol)
        push!(member_names, b)
        push!(member_decls, b)
    end
    function add_field(__source__, b::Expr)
        if b.head === :block
            add_fields(__source__, b)
        elseif b.head === :const
            add_field(__source__, b.args[1])
        elseif b.head === :(::) && b.args[1] isa Symbol
            push!(member_names, b.args[1])
            push!(member_decls, b)
        elseif b.head === :macrocall
            add_field(__source__, b.args[3])
        elseif b.head === :function || b.head === :(=) && (b.args[1] isa Expr && b.args[1].head in (:call, :where))
            # :function, :equals:call, :equals:where are defining functions - inner constructors
            # we don't want to permit that if it would interfere with us producing them.
            prevent_inner_constructors &&
                error_usage(__source__, "macro @auto_hash_equals should not be used on a struct that declares an inner constructor.")
        end
    end
    function add_fields(__source__, b::Expr)
        @assert b.head === :block
        for field in b.args
            if field isa LineNumberNode
                __source__ = field
            else
                add_field(__source__, field)
            end
        end
    end

    @assert (struct_decl.args[3].head === :block)
    add_fields(__source__, struct_decl.args[3])
    return (member_names, member_decls)
end

function check_valid_alt_hash_name(__source__, alt_hash_name)
    isnothing(alt_hash_name) || alt_hash_name isa Symbol || is_expr(alt_hash_name, :.) ||
        error_usage(__source__, "invalid alternate hash function name: `$alt_hash_name`.")
end

isexpr(e, head) = e isa Expr && e.head == head
isexpr(e, head, n) = isexpr(e, head) && length(e.args) == n

function auto_hash_equals_impl(__source__::LineNumberNode, typ; kwargs...)
    # These are the default values of the keyword arguments
    cache=false
    hashfn=nothing
    fields=nothing
    typearg=false
    typeseed=nothing
    compat1=false

    # Process the keyword arguments
    for kw in kwargs
        @assert kw isa Pair
        @assert kw.first isa Symbol
        if kw.first === :cache
            if !(kw.second isa Bool)
                error_usage(__source__, "`cache` argument must be a Bool, but got `$(kw.second)`.")
            end
            cache = kw.second
        elseif kw.first === :typearg
            if !(kw.second isa Bool)
                error_usage(__source__, "`typearg` argument must be a Bool, but got `$(kw.second)`.")
            end
            typearg = kw.second
        elseif kw.first === :hashfn
            if !(kw.second isa Union{Symbol, Expr, Function})
                error_usage(__source__, "`hashfn` argument must name a function, but got `$(kw.second)`.")
            end
            hashfn = kw.second
            check_valid_alt_hash_name(__source__, hashfn)
        elseif kw.first === :fields
            if !(kw.second isa Tuple) || !all(f isa Symbol for f in kw.second)
                error_usage(__source__, "invalid `fields` argument: `$(kw.second)`.")
            end
            fields = kw.second
        elseif kw.first === :typeseed
            typeseed = kw.second
        elseif kw.first === :compat1
            if !(kw.second isa Bool)
                error_usage(__source__, "`compat1` argument must be a Bool, but got `$(kw.second)`.")
            end
            compat1 = kw.second
        else
            error_usage(__source__, "invalid keyword argument for @auto_hash_equals: `$(kw.first)`.")
        end
    end

    typ = get_struct_decl(__source__::LineNumberNode, typ)

    auto_hash_equals_impl(__source__, typ, fields, cache, hashfn, typearg, typeseed, compat1)
end

function auto_hash_equals_impl(__source__, struct_decl, fields, cache::Bool, hashfn, typearg::Bool, typeseed, compat1::Bool)
    is_expr(struct_decl, :struct) || error_usage(__source__)

    type_body = struct_decl.args[3].args

    (!cache || !struct_decl.args[1]) ||
        error_usage(__source__, "macro `@auto_hash_equals`` with `cached=true`` should only be applied to a non-mutable struct.")

    (type_name, full_type_name, where_list) = unpack_type_name(__source__, struct_decl.args[2])
    @assert type_name isa Symbol

    (member_names, member_decls) = get_fields(__source__, struct_decl; prevent_inner_constructors=cache)
    if isnothing(fields)
        fields = (member_names...,)
    else
        for f in fields
            f isa Symbol ||
                error_usage(__source__, "invalid field name: `$f`.")
            f in member_names ||
                error_usage(__source__, "field `$f` not found in struct `$type_name`.")
        end
    end

    base_hash_name = :($Base.hash)
    if isnothing(hashfn)
        hashfn = base_hash_name
    end

    # Add the cache field to the body of the struct
    if cache
        push!(type_body, :(_cached_hash::UInt))

        # Add the internal constructor
        hash_init = if isnothing(typeseed)
            if typearg
                :($type_seed($full_type_name))
            else
                :($hashfn($(QuoteNode(type_name))))
            end
        else
            if typearg
                :(UInt($typeseed($full_type_name)))
            else
                :(UInt($typeseed))
            end
        end
        compute_hash = foldl(
            (r, a) -> :($hashfn($a, $r)),
            fields;
            init = hash_init)
        ctor_body = :(new($(member_names...), $compute_hash))
        if isnothing(where_list)
            push!(type_body, :(function $full_type_name($(member_names...))
                $ctor_body
            end))
        else
            push!(type_body, :(function $full_type_name($(member_names...)) where {$(where_list...)}
                $ctor_body
            end))
        end
    end

    result = Expr(:block, __source__, esc(struct_decl), __source__)

    # add function for hash(x, h). hash(x)
    if cache
        push!(result.args, esc(:(function $hashfn(x::$type_name, h::UInt)
            $hashfn(x._cached_hash, h)
        end)))
        push!(result.args, esc(:(function $hashfn(x::$type_name)
            x._cached_hash
        end)))
    else
        hash_init =
            if isnothing(typeseed)
                if typearg
                    :($type_seed($full_type_name, h))
                else
                    :($hashfn($(QuoteNode(type_name)), h))
                end
            else
                if typearg
                    :(UInt($typeseed($full_type_name, h)))
                else
                    :(h + UInt($typeseed))
                end
            end
        compute_hash = foldl(
            (r, a) -> :($hashfn($getfield(x, $(QuoteNode(a))), $r)),
            fields;
            init = hash_init)
        if typearg
            if isnothing(where_list)
                push!(result.args, esc(:(function $hashfn(x::$full_type_name, h::UInt)
                    $compute_hash
                end)))
            else
                push!(result.args, esc(:(function $hashfn(x::$full_type_name, h::UInt) where {$(where_list...)}
                    $compute_hash
                end)))
            end
        else
            push!(result.args, esc(:(function $hashfn(x::$type_name, h::UInt)
                $compute_hash
            end)))
        end
    end

    if hashfn != base_hash_name
        # add function for Base.hash(x, h)
        push!(result.args, esc(:(function $base_hash_name(x::$type_name, h::UInt)
            $hashfn(x, h)
        end)))
        if cache
            push!(result.args, esc(:(function $base_hash_name(x::$type_name)
                $hashfn(x)
            end)))
        end
    end

    # add function Base.show
    if cache
        push!(result.args, esc(:(function $Base._show_default(io::IO, x::$type_name)
            $_show_default_auto_hash_equals_cached(io, x)
        end)))
    end

    # Add function to interoperate with Rematch2 (eventually Match.jl) if loaded
    # at the time the macro is expanded.
    if_has_package("Match", Base.UUID("7eb4fadd-790c-5f42-8a69-bfa0b872bfbf"), v"2") do pkg
        if :match_fieldnames in names(pkg; all=true)
            push!(result.args, esc(:(function $pkg.match_fieldnames(::Type{$type_name})
                $((fields...,))
            end)))
        end
    end

    if cache && !isnothing(where_list)
        # for generic types, we add an external constructor to perform ctor type inference:
        push!(result.args, esc(quote
            $type_name($(member_decls...)) where {$(where_list...)} = $full_type_name($(member_names...))
        end))
    end

    # Add the `==` and `isequal` functions
    for eq in (==, isequal)
        # In compat mode, only define ==
        eq == isequal && compat1 && continue

        if eq == isequal || compat1
            equality_impl = foldl(
                (r, f) -> :($r && $isequal($getfield(a, $(QuoteNode(f))), $getfield(b, $(QuoteNode(f))))),
                fields;
                init = cache ? :(a._cached_hash == b._cached_hash) : true)
            if struct_decl.args[1]
                # mutable structs can efficiently be compared by reference
                # Note this optimization is only valid for `isequal`, e.g.
                # a = [missing]
                # a == a # missing
                # isequal(a, a) # true
                equality_impl = :(a === b || $equality_impl)
            end
        else
            # Here we have a more complicated implementation in order to handle missings correctly.
            # If any field comparison is false, we return false (even if some return missing).
            # If no field comparisons are false, but one comparison missing, then we return missing.
            # Otherwise we return true.
            # (This matches the semantics of `==` for `Tuple`'s and `NamedTuple`'s.)
            equality_impl = Expr(:block, :(found_missing = false))
            if cache
                push!(equality_impl.args, :(a._cached_hash != b._cached_hash && return false))
            end
            for f in fields
                push!(equality_impl.args, :(cmp = $getfield(a, $(QuoteNode(f))) == $getfield(b, $(QuoteNode(f)))))
                push!(equality_impl.args, :(cmp === false && return false))
                push!(equality_impl.args, :($ismissing(cmp) && (found_missing = true)))
            end
            push!(equality_impl.args, :(return $ifelse(found_missing, missing, true)))
        end

        fn_name = Symbol(eq)
        if isnothing(where_list) || !typearg
            push!(result.args, esc(:(function ($Base).$fn_name(a::$type_name, b::$type_name)
                $equality_impl
            end)))
        else
            # If requested, require the type arguments be the same for two instances to be equal
            push!(result.args, esc(:(function ($Base).$fn_name(a::$full_type_name, b::$full_type_name) where {$(where_list...)}
                $equality_impl
            end)))
        end
    end

    # Evaluating a struct declaration normally returns the struct itself.
    # we preserve that behavior when the macro is used.
    # We also relay documentation to the struct type.
    push!(result.args, esc(:(Base.@__doc__ $type_name)))

    return result
end

module Compat

using AutoHashEquals: AutoHashEquals

export @auto_hash_equals

"""
    @auto_hash_equals [options] struct Foo ... end

Generate `Base.hash`, `Base.isequal`, and `Base.==` methods for `Foo`.

Options:

* `cache=true|false` whether or not to generate an extra cache field to store the precomputed hash value. Default: `false`.
* `hashfn=myhash` the hash function to use. Default: `Base.hash`.
* `fields=a,b,c` the fields to use for hashing and equality. Default: all fields.
* `typearg=true|false` whether or not to make type arguments significant. Default: `false`.
* `typeseed=e` Use `e` (or `e(type)` if `typearg=true`) as the seed for hashing type arguments.
* `compat1=true` To have `==` defined by using `isequal`.  Default: `true`.
"""
macro auto_hash_equals(args...)
    esc(:($AutoHashEquals.@auto_hash_equals(compat1=true, $(args...))))
end

end

# SPDX-License-Identifier: MIT

include("compat.jl")

module runtests

using AutoHashEquals: AutoHashEquals, @auto_hash_equals
using Markdown: plain
using Match: Match, @match, MatchFailure
using Random
using Serialization
using Test

# Import private member for test purposes
using AutoHashEquals: type_seed

function serialize_and_deserialize(x)
    buf = IOBuffer()
    serialize(buf, x)
    seekstart(buf)
    deserialize(buf)
end

macro noop(x)
    esc(x)
end

"""
    @auto_hash_equals_cached struct Foo ... end

Shorthand for @auto_hash_equals cache=true struct Foo ... end
"""
macro auto_hash_equals_cached(typ)
    esc(Expr(:macrocall, var"@auto_hash_equals", __source__, :(cache = true), typ))
end

# some custom hash function
function myhash end
myhash(o::T, h::UInt) where {T} = error("myhash not implemented for $T")
myhash(o::UInt, h::UInt) = xor(o, h)
myhash(o::Symbol, h::UInt) = Base.hash(o, h)
myhash(o::Type, h::UInt) = myhash(o.name.name, h)
myhash(o) = myhash(o, UInt(0x0))

# Some types for testing interoperation with `Match.jl`
struct R157; x; y; end
@auto_hash_equals_cached struct R158; x; y::Int; end
@auto_hash_equals_cached struct R159{T}; x; y::T; end

@auto_hash_equals fields=(a, b) struct R477
    a
    b
    ignore_me
end
@auto_hash_equals cache=true fields=(a, b) struct R478
    a
    b
    ignore_me
end

struct G{T, U}
    x::T
    y::U
end

abstract type Q end
abstract type B{T} end
@enum E e1 e2 e3

@testset "AutoHashEquals.jl" begin

    @testset "tests for @auto_hash_equals_cached" begin

        @testset "macro preserves comments 1" begin
            """a comment"""
            @auto_hash_equals_cached struct T23
                x
            end
            @test plain(@doc T23) == "a comment\n"
        end

        @testset "macro preserves comments 2" begin
            """a comment"""
            @auto_hash_equals_cached @noop struct T26
                x
            end
            @test plain(@doc T26) == "a comment\n"
        end

        @testset "macro preserves comments 3" begin
            """a comment"""
            @noop @auto_hash_equals_cached struct T30
                @noop x
            end
            @test plain(@doc T30) == "a comment\n"
        end

        @testset "the macro sees through other macros and `begin`" begin
            @auto_hash_equals_cached @noop struct T32
                @noop begin
                    @noop x
                end
            end
            @test T32(1) == T32(1)
            @test hash(T32(1)) == hash(T32(1))
            @test hash(T32(1)) != hash(T32(2))
        end

        @testset "the macro sees through `const`" begin
            T33 = eval(:(@auto_hash_equals mutable struct T33
                const x
            end))
            @test T33(1) == T33(1)
            @test hash(T33(1)) == hash(T33(1))
            @test hash(T33(1)) != hash(T33(2))
        end

        @testset "misuse of the macro" begin
            @test_throws Exception @eval @auto_hash_equals a struct T34 end
        end

        @testset "invalid type name 1" begin
            @test_throws Exception @eval @auto_hash_equals_cached struct 1 end
        end

        @testset "invalid type name 2" begin
            @test_throws Exception @eval @auto_hash_equals_cached struct a.b end
        end

        @testset "empty struct" begin
            @auto_hash_equals_cached struct T35 end
            @test T35() isa T35
            @test hash(T35()) == hash(:T35)
            @test hash(T35(), UInt(0)) == hash(hash(:T35), UInt(0))
            @test hash(T35(), UInt(1)) == hash(hash(:T35), UInt(1))
            @test T35() == T35()
            @test T35() == serialize_and_deserialize(T35())
            @test hash(T35()) == hash(serialize_and_deserialize(T35()))
            @test "$(T35())" == "$(T35)()"
        end

        @testset "struct with members" begin
            @auto_hash_equals_cached struct T48
                x; y
            end
            @test T48(1, :x) isa T48
            @test hash(T48(1, :x)) == hash(:x,hash(1,hash(:T48)))
            @test T48(1, :x) == T48(1, :x)
            @test T48(1, :x) != T48(2, :x)
            @test hash(T48(1, :x)) != hash(T48(2, :x))
            @test T48(1, :x) != T48(1, :y)
            @test hash(T48(1, :x)) != hash(T48(1, :y))
            @test T48(1, :x) == serialize_and_deserialize(T48(1, :x))
            @test hash(T48(1, :x)) == hash(serialize_and_deserialize(T48(1, :x)))
            @test "$(T48(1, :x))" == "$(T48)(1, :x)"
        end

        @testset "generic struct with members" begin
            @auto_hash_equals cache=true typearg=true struct T63{G}
                x
                y::G
            end
            @test T63{Symbol}(1, :x) isa T63
            @test hash(T63{Symbol}(1, :x)) == hash(:x,hash(1,type_seed(T63{Symbol})))
            @test hash(T63{Symbol}(1, :x)) != hash(T63{Any}(1, :x))
            @test T63{Symbol}(1, :x) != T63{Any}(1, :x) # note: type args are significant
            @test T63{Symbol}(1, :x) == T63{Symbol}(1, :x)
            @test T63{Symbol}(1, :x) != T63{Symbol}(2, :x)
            @test hash(T63{Symbol}(1, :x)) != hash(T63{Symbol}(2, :x))
            @test T63{Symbol}(1, :x) != T63{Symbol}(1, :y)
            @test hash(T63{Symbol}(1, :x)) != hash(T63{Symbol}(1, :y))
            @test T63{Symbol}(1, :x) == serialize_and_deserialize(T63{Symbol}(1, :x))
            @test hash(T63{Symbol}(1, :x)) == hash(serialize_and_deserialize(T63{Symbol}(1, :x)))
        end

        @testset "inheritance from an abstract base" begin
            abstract type Base81 end
            @auto_hash_equals_cached struct T81a<:Base81 x end
            @auto_hash_equals_cached struct T81b<:Base81 x end
            @test T81a(1) isa T81a
            @test T81a(1) isa Base81
            @test T81b(1) isa T81b
            @test T81b(1) isa Base81
            @test T81a(1) != T81b(1)
            @test T81a(1) == T81a(1)
            @test serialize_and_deserialize(T81a(1)) isa T81a
            @test T81a(1) == serialize_and_deserialize(T81a(1))
            @test hash(T81a(1)) == hash(serialize_and_deserialize(T81a(1)))
        end

        @testset "generic bounds" begin
            abstract type Base107{T<:Union{String, Int}} end
            @auto_hash_equals cache=true typearg=true struct T107a{T}<:Base107{T} x::T end
            @auto_hash_equals cache=true typearg=true struct T107b{T}<:Base107{T} x::T end
            @test T107a(1) isa T107a
            @test T107a(1) == T107a(1)
            @test T107a(1) == serialize_and_deserialize(T107a(1))
            @test T107a(1) != T107a(2)
            @test hash(T107a(1)) == hash(1, type_seed(T107a{Int}))
            @test hash(T107a("x")) == hash("x", type_seed(T107a{String}))
            @test hash(T107a(1)) != hash(T107b(1))
            @test hash(T107a(1)) != hash(T107a(2))
        end

        @testset "macro applied to type before @auto_hash_equals_cached" begin
            @noop @auto_hash_equals_cached struct T116
                x::Int
                y
            end
            @test T116(1, :x) isa T116
            @test hash(T116(1, :x)) == hash(:x,hash(1,hash(:T116)))
            @test T116(1, :x) == T116(1, :x)
            @test T116(1, :x) != T116(2, :x)
            @test hash(T116(1, :x)) != hash(T116(2, :x))
            @test T116(1, :x) != T116(1, :y)
            @test hash(T116(1, :x)) != hash(T116(1, :y))
            @test T116(1, :x) == serialize_and_deserialize(T116(1, :x))
            @test hash(T116(1, :x)) == hash(serialize_and_deserialize(T116(1, :x)))
        end

        @testset "macro applied to type after @auto_hash_equals_cached" begin
            @auto_hash_equals_cached @noop struct T132
                x::Int
                y
            end
            @test T132(1, :x) isa T132
            @test hash(T132(1, :x)) == hash(:x,hash(1,hash(:T132)))
            @test T132(1, :x) == T132(1, :x)
            @test T132(1, :x) != T132(2, :x)
            @test hash(T132(1, :x)) != hash(T132(2, :x))
            @test T132(1, :x) != T132(1, :y)
            @test hash(T132(1, :x)) != hash(T132(1, :y))
            @test T132(1, :x) == serialize_and_deserialize(T132(1, :x))
            @test hash(T132(1, :x)) == hash(serialize_and_deserialize(T132(1, :x)))
        end

        @testset "macro applied to members" begin
            @auto_hash_equals_cached @noop struct T135
                @noop x::Int
                @noop y
            end
            @test T135(1, :x) isa T135
            @test hash(T135(1, :x)) == hash(:x,hash(1,hash(:T135)))
            @test T135(1, :x) == T135(1, :x)
            @test T135(1, :x) != T135(2, :x)
            @test hash(T135(1, :x)) != hash(T135(2, :x))
            @test T135(1, :x) != T135(1, :y)
            @test hash(T135(1, :x)) != hash(T135(1, :y))
            @test T135(1, :x) == serialize_and_deserialize(T135(1, :x))
            @test hash(T135(1, :x)) == hash(serialize_and_deserialize(T135(1, :x)))
        end

        @testset "contained NaN values compare isequal (but not ==)" begin
            @auto_hash_equals_cached struct T140
                x
            end
            nan = 0.0 / 0.0
            @test nan != nan
            @test isequal(T140(nan), T140(nan))
            @test T140(nan) != T140(nan)

        end

        @testset "circular data structures behavior" begin
            @auto_hash_equals_cached struct T145
                a::Array{Any,1}
            end
            t::T145 = T145(Any[1])
            t.a[1] = t
            # hash does not stack overflow thanks to the cache
            @test hash(t) != 0
            # `==` overflows
            @test_throws StackOverflowError t == t
            # isequal does not
            @test isequal(t, t)
            @test !isequal(t, T145(Any[]))
            # Check printing
            @test "$t" == "$(T145)(Any[$(T145)(#= circular reference @-2 =#)])"
        end

        # @test_throws requires a type before v1.8.
        internal_constructor_error = ErrorException

        @testset "give an error if the struct contains internal constructors 1" begin
            @test_throws internal_constructor_error begin
                @macroexpand @auto_hash_equals_cached struct T150
                    T150() = new()
                end
            end
        end

        @testset "give an error if the struct contains internal constructors 2" begin
            @test_throws internal_constructor_error begin
                @macroexpand @auto_hash_equals_cached struct T152
                    T152() where {T} = new()
                end
            end
        end

        @testset "give an error if the struct contains internal constructors 3" begin
            @test_throws internal_constructor_error begin
                @macroexpand @auto_hash_equals_cached struct T154
                    function T154()
                        new()
                    end
                end
            end
        end

        @testset "test interoperation with Match" begin

            @testset "test simple Match usage" begin
                @test (Match.@match R157(z,2) = R157(1,2)) == R157(1,2) && z == 1
                @test_throws Match.MatchFailure Match.@match R157(x, 3) = R157(1,2)
                @test (Match.@match R157(1,2) begin
                    R157(x=x1,y=y1) => (x1,y1)
                end) == (1,2)
            end

            @testset "make sure Match works for types with cached hash code" begin
                @test (Match.@match R158(x,2) = R158(1,2)) == R158(1,2) && x == 1
                @test_throws Match.MatchFailure Match.@match R158(x, 3) = R158(1,2)
                @test (Match.@match R158(1,2) begin
                    R158(x=x1,y=y1) => (x1,y1)
                end) == (1,2)
            end

            @testset "make sure Match works for generic types with cached hash code" begin
                @test (Match.@match R159(x,2) = R159(1,2)) == R159(1,2) && x == 1
                @test_throws Match.MatchFailure Match.@match R159(x, 3) = R159(1,2)
                @test (Match.@match R159(1,2) begin
                    R159(x=x1,y=y1) => (x1,y1)
                end) == (1,2)
            end

        end

        @testset "give an error if the struct contains internal constructors 4" begin
            @test_throws internal_constructor_error begin
                @macroexpand @auto_hash_equals_cached struct T156
                    function T156() where {T}
                        new()
                    end
                end
            end
        end

        @testset "check compatibility with default constructor" begin
            @auto_hash_equals_cached struct S268
                x::Int
            end
            @test S268(2.0).x === 2
            @auto_hash_equals_cached struct S269{T <: Any}
                x::T
            end
            @test S269{Int}(2.0).x === 2
            @test S269(2.0).x === 2.0
        end
    end

    @testset "tests for @auto_hash_equals" begin

        @testset "macro preserves comments 1" begin
            """a comment"""
            @auto_hash_equals struct T160
                x
            end
            @test plain(@doc T160) == "a comment\n"
        end

        @testset "macro preserves comments 2" begin
            """a comment"""
            @auto_hash_equals @noop struct T165
                x
            end
            @test plain(@doc T165) == "a comment\n"
        end

        @testset "macro preserves comments 3" begin
            """a comment"""
            @noop @auto_hash_equals struct T170
                @noop x
            end
            @test plain(@doc T170) == "a comment\n"
        end

        @testset "empty struct" begin
            @auto_hash_equals struct T176 end
            @test T176() isa T176
            @test hash(T176()) == hash(:T176, UInt(0))
            @test hash(T176(), UInt(1)) == hash(:T176, UInt(1))
            @test hash(T176(), UInt(1)) != hash(:T176, UInt(0))
            @test T176() == T176()
            @test T176() == serialize_and_deserialize(T176())
            @test hash(T176()) == hash(serialize_and_deserialize(T176()))
        end

        @testset "struct with members" begin
            @auto_hash_equals struct T186
                x; y
            end
            @test T186(1, :x) isa T186
            @test hash(T186(1, :x)) == hash(:x,hash(1,hash(:T186, UInt(0))))
            @test T186(1, :x) == T186(1, :x)
            @test T186(1, :x) != T186(2, :x)
            @test hash(T186(1, :x)) != hash(T186(2, :x))
            @test T186(1, :x) != T186(1, :y)
            @test hash(T186(1, :x)) != hash(T186(1, :y))
            @test T186(1, :x) == serialize_and_deserialize(T186(1, :x))
            @test hash(T186(1, :x)) == hash(serialize_and_deserialize(T186(1, :x)))
        end

        @testset "generic struct with members" begin
            @auto_hash_equals typearg=false struct T201{G}
                x
                y::G
            end
            @test T201{Symbol}(1, :x) isa T201
            @test hash(T201{Symbol}(1, :x)) == hash(:x,hash(1,hash(:T201, UInt(0))))
            @test hash(T201{Symbol}(1, :x)) == hash(T201{Any}(1, :x))
            @test T201{Symbol}(1, :x) == T201{Any}(1, :x) # note: type args are not significant
            @test T201{Symbol}(1, :x) == T201{Symbol}(1, :x)
            @test T201{Symbol}(1, :x) != T201{Symbol}(2, :x)
            @test hash(T201{Symbol}(1, :x)) != hash(T201{Symbol}(2, :x))
            @test T201{Symbol}(1, :x) != T201{Symbol}(1, :y)
            @test hash(T201{Symbol}(1, :x)) != hash(T201{Symbol}(1, :y))
            @test T201{Symbol}(1, :x) == serialize_and_deserialize(T201{Symbol}(1, :x))
            @test hash(T201{Symbol}(1, :x)) == hash(serialize_and_deserialize(T201{Symbol}(1, :x)))
        end

        @testset "inheritance from an abstract base" begin
            abstract type Base219 end
            @auto_hash_equals struct T219a<:Base219 x end
            @auto_hash_equals struct T219b<:Base219 x end
            @test T219a(1) isa T219a
            @test T219a(1) isa Base219
            @test T219b(1) isa T219b
            @test T219b(1) isa Base219
            @test T219a(1) != T219b(1)
            @test T219a(1) == T219a(1)
            @test serialize_and_deserialize(T219a(1)) isa T219a
            @test T219a(1) == serialize_and_deserialize(T219a(1))
            @test hash(T219a(1)) == hash(serialize_and_deserialize(T219a(1)))
            @test hash(T219a(1)) == hash(1, hash(:T219a, UInt(0)))
        end

        @testset "generic bounds" begin
            abstract type Base225{T<:Union{String, Int}} end
            @auto_hash_equals typearg=false struct T225a{T}<:Base225{T} x::T end
            @auto_hash_equals typearg=false struct T225b{T}<:Base225{T} x::T end
            @test T225a(1) == T225a(1)
            @test T225a(1) == serialize_and_deserialize(T225a(1))
            @test T225a(1) != T225a(2)
            @test hash(T225a(1)) == hash(1, hash(:T225a, UInt(0)))
            @test hash(T225a("x")) == hash("x", hash(:T225a, UInt(0)))
            @test hash(T225a(1)) != hash(T225b(1))
            @test hash(T225a(1)) != hash(T225a(2))
        end

        @testset "macro applied to type before @auto_hash_equals" begin
            @noop @auto_hash_equals struct T238
                x::Int
                y
            end
            @test T238(1, :x) isa T238
            @test hash(T238(1, :x)) == hash(:x,hash(1,hash(:T238, UInt(0))))
            @test T238(1, :x) == T238(1, :x)
            @test T238(1, :x) != T238(2, :x)
            @test hash(T238(1, :x)) != hash(T238(2, :x))
            @test T238(1, :x) != T238(1, :y)
            @test hash(T238(1, :x)) != hash(T238(1, :y))
            @test T238(1, :x) == serialize_and_deserialize(T238(1, :x))
            @test hash(T238(1, :x)) == hash(serialize_and_deserialize(T238(1, :x)))
        end

        @testset "macro applied to type after @auto_hash_equals" begin
            @auto_hash_equals @noop struct T254
                x::Int
                y
            end
            @test T254(1, :x) isa T254
            @test hash(T254(1, :x)) == hash(:x,hash(1,hash(:T254, UInt(0))))
            @test T254(1, :x) == T254(1, :x)
            @test T254(1, :x) != T254(2, :x)
            @test hash(T254(1, :x)) != hash(T254(2, :x))
            @test T254(1, :x) != T254(1, :y)
            @test hash(T254(1, :x)) != hash(T254(1, :y))
            @test T254(1, :x) == serialize_and_deserialize(T254(1, :x))
            @test hash(T254(1, :x)) == hash(serialize_and_deserialize(T254(1, :x)))
        end

        @testset "macro applied to members" begin
            @auto_hash_equals @noop struct T313
                @noop x::Int
                @noop y
            end
            @test T313(1, :x) isa T313
            @test hash(T313(1, :x)) == hash(:x,hash(1,hash(:T313, UInt(0))))
            @test T313(1, :x) == T313(1, :x)
            @test T313(1, :x) != T313(2, :x)
            @test hash(T313(1, :x)) != hash(T313(2, :x))
            @test T313(1, :x) != T313(1, :y)
            @test hash(T313(1, :x)) != hash(T313(1, :y))
            @test T313(1, :x) == serialize_and_deserialize(T313(1, :x))
            @test hash(T313(1, :x)) == hash(serialize_and_deserialize(T313(1, :x)))
        end

        @testset "contained NaN values compare isequal (but not ==)" begin
            @auto_hash_equals struct T330
                x
            end
            nan = 0.0 / 0.0
            @test nan != nan
            @test isequal(T330(nan), T330(nan))
            @test T330(nan) != T330(nan)
        end

        @testset "give no error if the struct contains internal constructors" begin
            @auto_hash_equals struct T350
                T350() = new()
            end
        end

        @testset "check that we can define custom hash function" begin
            @auto_hash_equals hashfn=runtests.myhash struct S470
                x::UInt
            end
            q, r = rand(RandomDevice(), UInt, 2)
            @test myhash(S470(q)) == hash(S470(q))
            @test myhash(S470(q), r) == hash(S470(q), r)
            r !== 0 && @test myhash(S470(q), r) != hash(S470(q))
        end

        @testset "fields are obeyed for the hash function and for pattern-matching 1" begin
            a = R477(1, 2, 3)
            b = R477(1, 2, 4)
            c = R477(1, 3, 3)
            d = R477(2, 2, 3)
            @test a == b
            @test a != c
            @test a != d
            @test c != d
            @test hash(a) == hash(b)
            @test hash(a) != hash(c)
            @test hash(a) != hash(d)
            @test hash(c) != hash(d)
            @test @match a begin
                R477(1, 2) => true
                _ => false
            end
        end

        @testset "fields are obeyed for the hash function and for pattern-matching 2" begin
            a = R478(1, 2, 3)
            b = R478(1, 2, 4)
            c = R478(1, 3, 3)
            d = R478(2, 2, 3)
            @test a == b
            @test a != c
            @test a != d
            @test c != d
            @test hash(a) == hash(b)
            @test hash(a) != hash(c)
            @test hash(a) != hash(d)
            @test hash(c) != hash(d)
            @test @match a begin
                R478(1, 2) => true
                _ => false
            end
        end

        @testset "you may not name nonexistent fields" begin
            @test_throws Exception @eval @auto_hash_equals fields=(x, z) struct S477
                x
                y
            end
        end

        @testset "bad field name" begin
            @test_throws Exception @eval @auto_hash_equals fields=(x, 1) struct S478
                x
                y
            end
        end

        @testset "You may name a single field" begin
            @auto_hash_equals fields=(x) struct S479
                x
                y
            end
            @test S479(1, 2) == S479(1, 3)
            @test hash(S479(1, 2)) == hash(S479(1, 3))
        end

        @testset "Test when type included in hash 1" begin
            @auto_hash_equals typearg=true struct S590{T}
                x::T
            end
            @test hash(S590{Int}(1)) == hash(1, type_seed(S590{Int}, UInt(0)))
            @test hash(S590{Int}(1), UInt(0x2)) == hash(1, type_seed(S590{Int}, UInt(0x2)))
            @test S590{Int}(1) != S590{Any}(1)
            @test hash(S590{Int}(1)) != hash(S590{Any}(1))
        end

        @testset "Test when type included in hash 2" begin
            @auto_hash_equals typearg=true cache=true struct S597{T}
                x::T
            end
            @test hash(S597{Int}(1)) == hash(1, type_seed(S597{Int}, UInt(0)))
            @test hash(S597{Int}(1), UInt(0x2)) == hash(hash(1, type_seed(S597{Int}, UInt(0))), UInt(0x2))
        end

        @testset "Test when type NOT included in hash 1" begin
            @auto_hash_equals typearg=false struct S607{T}
                x::T
            end
            @test hash(S607{Int}(1)) == hash(1, hash(:S607, UInt(0)))
            @test hash(S607{Int}(1), UInt(0x2)) == hash(1, hash(:S607, UInt(0x2)))
        end

        @testset "Test when type NOT included in hash 2" begin
            @auto_hash_equals typearg=false cache=true struct S615{T}
                x::T
            end
            @test hash(S615{Int}(1)) == hash(1, hash(:S615))
            @test hash(S615{Int}(1), UInt(0x2)) == hash(hash(1, hash(:S615)), UInt(0x2))
        end

        @testset "typearg keyword parameter must be a bool" begin
            @test_throws Exception @eval @auto_hash_equals typearg=1 struct S625{T}
                x::T
            end
        end

        @testset "check that type arguments are ignored by default" begin
            @auto_hash_equals struct Box629{T}
                x::T
            end
            @test Box629{Int}(1) == Box629{Any}(1)
            @test hash(Box629{Int}(1)) == hash(Box629{Any}(1))
        end

        @testset "Check that by default the hash function is stable after 1.7" begin
            # The value of `Base.hash(:x, UInt(0))` changed in 1.7, so it was already
            # unstable between 1.6 and 1.7.  Here we just add tests so that future
            # changes to the hash function will be observed.

            @auto_hash_equals struct Box1
                x
            end

            @test 0x05014b35fc91d289 === hash(Box1(1))
            @test 0x91d7652c7a24efb3 === hash(Box1(:x))
            @test 0x1d9ac96f957cc50a === hash(Box1("a"))
            @test 0x6e0378444e962be8 === hash(Box1(1), UInt(1))
            @test 0xa31a1cd3c72d944c === hash(Box1(:x), UInt(1))
            @test 0xe563b59c847e3d2f === hash(Box1("a"), UInt(1))

            @auto_hash_equals struct Box2{T}
                x::T
            end

            @test 0xfddfe30b106aa2f0 === hash(Box2(1))
            @test 0xfddfe30b106aa2f0 === hash(Box2{Any}(1))
            @test 0xb9abdfa5883b32bb === hash(Box2(:x))
            @test 0x6c49b14653a071c6 === hash(Box2("a"))
            @test 0x451b0ebf9ee0f99c === hash(Box2(1), UInt(1))
            @test 0x451b0ebf9ee0f99c === hash(Box2{Any}(1), UInt(1))
            @test 0x175e9079609f34c5 === hash(Box2(:x), UInt(1))
            @test 0x77cf64ab93060d1e === hash(Box2("a"), UInt(1))

            @auto_hash_equals struct Box3
                x
            end

            @test 0x6c8a62ecebe7d0ce === hash(Box3(1))
            @test 0xb3dc0f774c8dbf65 === hash(Box3(:x))
            @test 0x18c77bdc2543b944 === hash(Box3("a"))
            @test 0x1fe5e7cdd29edab1 === hash(Box3(1), UInt(1))
            @test 0x55e8647bf53d5ecd === hash(Box3(:x), UInt(1))
            @test 0xf556f204c1f1bc53 === hash(Box3("a"), UInt(1))

            @auto_hash_equals struct Box4{T}
                x::T
            end

            @test 0x98dc0cd9a86cbdee === hash(Box4(1))
            @test 0x98dc0cd9a86cbdee === hash(Box4{Any}(1))
            @test 0x3dbd99c859966133 === hash(Box4(:x))
            @test 0xa7d6e8579ef5a8cd === hash(Box4("a"))
            @test 0x44ac08ef000cb686 === hash(Box4(1), UInt(1))
            @test 0x44ac08ef000cb686 === hash(Box4{Any}(1), UInt(1))
            @test 0xc7dc8347992b452d === hash(Box4(:x), UInt(1))
            @test 0x3dcb6b6168a2c18d === hash(Box4("a"), UInt(1))

        end

        @testset "ensure that type_seed(x) is stable" begin
            @test 0x4ae3767494b4cfaa === type_seed(Int)
            @test 0xb6c8f68810a16d66 === type_seed(String)

            @test 0x3215757a8995a661 === type_seed(G)
            @test 0x3215757a8995a661 === type_seed(G{T, U} where { T, U })
            @test 0xc6e6e47d689b8517 === type_seed(G{T, U} where { T <: Int, U <: String })
            @test 0xaa10d1f6a9b7e132 === type_seed(G{Int, String})
            @test 0xa740a4a4fc06d108 === type_seed(G{Int, T} where T)
            @test 0x7ab308cb793c5618 === type_seed(G{T, String} where T)
            @test 0xd02856316b177631 === type_seed(G{T, T} where T)
            @test 0xd02856316b177631 === type_seed(G{T, T} where T)
            @test 0xd3251f72348b86e2 === type_seed(G{G{T, Int}, G{T, String}} where T)
            @test 0xd3251f72348b86e2 === type_seed(G{G{T, Int}, G{T, String}} where T)

            @test 0x77f9d59da65a76bf === type_seed(Q)
            @test 0xb1241c9348842d51 === type_seed(B)
            @test 0xb1241c9348842d51 === type_seed(B{T} where { T })
            @test 0x9ae23988eb7c0716 === type_seed(B{T} where { T <: Int })
            @test 0xb3633f456e073d78 === type_seed(B{Int64})

            @test 0x5da6365f88849a43 === type_seed(Any)
            @test 0x3ea9a6632d35bdba === type_seed(Union{Int, String})
            @test 0x3cef2865f9232667 === type_seed(Union{})
            @test 0x7a86094a43978c16 === type_seed(Union)

            @test 0x29c3b5ce0a9c3a5b === type_seed(E)
            @test 0x00399c16f8744869 === type_seed(Tuple{})
            @test 0x00399c16f8744869 === type_seed(NTuple{0, Int})
            @test 0x808e1de371b0cce2 === type_seed(Tuple{String})
            @test 0x808e1de371b0cce2 === type_seed(NTuple{1, String})
            @test 0x899ca12a00ea1296 === type_seed(Tuple{String, Int})
            @test 0xf343d5b9c3ca4b77 === type_seed(@NamedTuple{a::Int, b::String})
            @test 0xf343d5b9c3ca4b77 === type_seed(typeof((a=1, b="")))
            @test 0xf7833397407626a0 === type_seed(typeof((a="", b=1)))
            @test 0xa4c046858bf076c3 === type_seed(NTuple{3, Int})
            @test 0x9977c31bb10d21bc === type_seed(Val{1})
            @test 0x19a63e87164d8e87 === type_seed(Val{:x})

            @test 0x789db08b2c84bf6c === type_seed(NTuple)
            @test 0x571b7e681184913a === type_seed(Tuple)
            @test hash(hash(1), UInt(0)) === type_seed(1)

            @test 0x9977c31bb10d21bc === type_seed(Val{1})
            @test 0xc19fa756b8cbf47d === type_seed(Val{:a})
            @test 0x7df4acaad2128daa === type_seed(Val{(1, :a)})
            @test 0xd5fb43db2f9427b4 === type_seed(Val{(1, :x)})
        end
    end

    @testset "test option typeseed=e" begin

        @testset "test typearg=true typeseed=hash generic type" begin
            @auto_hash_equals typearg=true typeseed=hash struct S640{T}
                w::T
            end
            @test hash(S640{Int}(1)) == hash(1, hash(S640{Int}))
            @test hash(S640{Int}(1), UInt(2)) == hash(1, hash(S640{Int}, UInt(2)))
        end

        @testset "test typearg=false typeseed=K generic type" begin
            @auto_hash_equals typearg=false typeseed=0x3dfe92e747bd4140 struct S642{T}
                w::T
            end
            @test hash(S642{Int}(1)) == hash(1, 0x3dfe92e747bd4140)
            @test hash(S642{Int}(1), UInt(2)) == hash(1, UInt(2) + 0x3dfe92e747bd4140)
        end

        @testset "test typearg=true typeseed=hash non-generic type" begin
            @auto_hash_equals typearg=true typeseed=hash struct S650
                w
            end
            @test hash(S650(1)) == hash(1, hash(S650))
            @test hash(S650(1), UInt(2)) == hash(1, hash(S650, UInt(2)))
        end

        @testset "test typearg=false typeseed=e non-generic type" begin
            @auto_hash_equals typearg=false typeseed=0x8dfd582f580f2e46 struct S658
                w
            end
            @test hash(S658(1)) == hash(1, 0x8dfd582f580f2e46)
            @test hash(S658(1), UInt(2)) == hash(1, UInt(2) + 0x8dfd582f580f2e46)
        end

        @testset "test using a constant for typeseed when a function is expected" begin
            @auto_hash_equals typearg=true typeseed=0x20cc10b97c7c95dd struct S674
                w
            end
            @test_throws MethodError hash(S674(1))
        end

        @testset "test using a function for typeseed when a constant is expected" begin
            @auto_hash_equals typearg=false typeseed=Base.hash struct S681
                w
            end
            @test_throws MethodError hash(S681(1))
        end


        @testset "== propogates missing, but `isequal` does not" begin
            # Fixed by https://github.com/JuliaServices/AutoHashEquals.jl/issues/18
            @auto_hash_equals struct Box18{T}
                x::T
            end
            ret = Box18(missing) == Box18(missing)
            @test ret === missing
            ret = Box18(missing) == Box18(1)
            @test ret === missing
            @test isequal(Box18(missing), Box18(missing))
            @test !isequal(Box18(missing), Box18(1))

            @auto_hash_equals struct Two18{T1, T2}
                x::T1
                y::T2
            end
            ret = Two18(1, missing) == Two18(1, 2)
            @test ret === missing

            ret = Two18(5, missing) == Two18(1, 2)
            @test ret === false

            ret = Two18(missing, 2) == Two18(1, 2)
            @test ret === missing

            ret = Two18(missing, 5) == Two18(1, 2)
            @test ret === false

            @auto_hash_equals mutable struct MutBox18{T}
                x::T
            end
            b = MutBox18(missing)
            ret = b == b
            @test ret === missing
            @test isequal(b, b)
        end

        @testset "test the compat1 flag" begin
            @auto_hash_equals struct Box890{T}
                x::T
            end
            @test ismissing(Box890(missing) == Box890(missing))
            @test isequal(Box890(missing), Box890(missing))
            @test ismissing(Box890(missing) == Box890(1))
            @test !isequal(Box890(missing), Box890(1))

            @auto_hash_equals compat1=true struct Box891{T}
                x::T
            end
            @test Box891(missing) == Box891(missing)
            @test isequal(Box891(missing), Box891(missing))
            @test Box891(missing) != Box891(1)
            @test !isequal(Box891(missing), Box891(1))
        end

    end
end

end # module
